import re
from constants import operations_map

t = "-2+22.5+22-(299*(100.5-9))/8"


def separator(text):
    symbols = []
    for i in re.split(r"[\d.]+", text):
        if i != '':
            symbols.append(i)
    if text[0] in symbols:
        t1 = text[0]
        text = text[1:]
        num = re.findall('\d*\.?\d+', text)
        numbers = list(map(float, num))
        if t1 == "+":
            symbols.pop(0)
        if t1 == "-":
            symbols.pop(0)
            numbers[0] = numbers[0] * -1
    else:
        num = re.findall('\d*\.?\d+', text)
        numbers = list(map(float, num))
    return numbers, symbols


def process(numbers, operation):
    if len(numbers) - 1 != len(operation):
        print("invalid inputs")
    result = numbers[0]
    for i in range(1, len(numbers)):
        if operation in operations_map:
            result = operations_map[operation](result, numbers[i])
        else:
            print("invalid operation")
    return result


def parentheses(text):
    if "(" in text:
        end_parentheses = text.index(")")
        temp =[]
        for i in text:
            temp.append(i)
        temp2 =[]
        for i, v in enumerate(temp):
            if v == "(":
                temp2.append(i)
        for i in temp2:
            if i > end_parentheses:
                start_parenthesis = temp2[i - 1]
            if temp2[-1] < end_parentheses:
                start_parenthesis = temp2[-1]
        new_text = text[start_parenthesis+1:end_parentheses]
        separated = separator(new_text)
        answer = order(separated[0], separated[1])
        another_new_text = text[:start_parenthesis] + str(answer[0]) + text[end_parentheses+1:]
        parentheses(another_new_text)
    else:
        separate = separator(text)
        last_answer = order(separate[0], separate[1])
        print(last_answer[0])


def order(numbers, symbols):
    while symbols:
        if "**" in symbols:
            result = process([numbers[symbols.index("**")], numbers[symbols.index("**") + 1]], "**")
            pop_add(numbers, symbols, result, "**")
        elif "*" in symbols or "/" in symbols:
            if "*" in symbols and "/" in symbols:
                if symbols.index("*") < symbols.index("/"):
                    result = process([numbers[symbols.index("*")], numbers[symbols.index("*") + 1]], "*")
                    pop_add(numbers, symbols, result, "*")
                else:
                    result = process([numbers[symbols.index("/")], numbers[symbols.index("/") + 1]], "/")
                    pop_add(numbers, symbols, result, "/")
            elif "*" in symbols:
                result = process([numbers[symbols.index("*")], numbers[symbols.index("*") + 1]], "*")
                pop_add(numbers, symbols, result, "*")

            else:
                result = process([numbers[symbols.index("/")], numbers[symbols.index("/") + 1]], "/")
                pop_add(numbers, symbols, result, "/")

        elif "+" in symbols or "-" in symbols:
            if "+" in symbols and "-" in symbols:
                if symbols.index("+") < symbols.index("-"):
                    result = process([numbers[symbols.index("+")], numbers[symbols.index("+") + 1]], "+")
                    pop_add(numbers, symbols, result, "+")
                else:
                    result = process([numbers[symbols.index("-")], numbers[symbols.index("-") + 1]], "-")
                    pop_add(numbers, symbols, result, "-")
            elif "*" in symbols:
                result = process([numbers[symbols.index("+")], numbers[symbols.index("+") + 1]], "+")
                pop_add(numbers, symbols, result, "+")

            else:
                result = process([numbers[symbols.index("-")], numbers[symbols.index("-") + 1]], "-")
                pop_add(numbers, symbols, result, "-")

    return numbers


def pop_add(numbers, symbols, result, symbol):
    numbers.pop(symbols.index(symbol) + 1)
    numbers[symbols.index(symbol)] = result
    symbols.pop(symbols.index(symbol))


parentheses(t)
print(eval(t))